// Generated by rstantools.  Do not edit by hand.

/*
    ppcseq is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ppcseq is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ppcseq.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#include <rstan/rstaninc.hpp>
// Code generated by Stan version 2.21.0
#include <stan/model/model_header.hpp>
namespace model_negBinomial_MPI_namespace {
using std::istream;
using std::string;
using std::stringstream;
using std::vector;
using stan::io::dump;
using stan::math::lgamma;
using stan::model::prob_grad;
using namespace stan::math;
static int current_statement_begin__;
stan::io::program_reader prog_reader__() {
    stan::io::program_reader reader;
    reader.add_event(0, 0, "start", "model_negBinomial_MPI");
    reader.add_event(275, 273, "end", "model_negBinomial_MPI");
    return reader;
}
template <bool propto, typename T0__, typename T1__, typename T2__>
typename boost::math::tools::promote_args<T0__, T1__, T2__>::type
exp_gamma_meanSd_lpdf(const Eigen::Matrix<T0__, Eigen::Dynamic, 1>& x_log,
                          const T1__& m_log,
                          const T2__& s, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T0__, T1__, T2__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 8;
        local_scalar_t__ m(DUMMY_VAR__);
        (void) m;  // dummy to suppress unused var warning
        stan::math::initialize(m, DUMMY_VAR__);
        stan::math::fill(m, DUMMY_VAR__);
        stan::math::assign(m,stan::math::exp(m_log));
        current_statement_begin__ = 9;
        local_scalar_t__ v(DUMMY_VAR__);
        (void) v;  // dummy to suppress unused var warning
        stan::math::initialize(v, DUMMY_VAR__);
        stan::math::fill(v, DUMMY_VAR__);
        stan::math::assign(v,(m + (square(m) * s)));
        current_statement_begin__ = 10;
        local_scalar_t__ a(DUMMY_VAR__);
        (void) a;  // dummy to suppress unused var warning
        stan::math::initialize(a, DUMMY_VAR__);
        stan::math::fill(a, DUMMY_VAR__);
        stan::math::assign(a,(square(m) / v));
        current_statement_begin__ = 11;
        local_scalar_t__ b(DUMMY_VAR__);
        (void) b;  // dummy to suppress unused var warning
        stan::math::initialize(b, DUMMY_VAR__);
        stan::math::fill(b, DUMMY_VAR__);
        stan::math::assign(b,(m / v));
        current_statement_begin__ = 13;
        validate_non_negative_index("jacob", "rows(x_log)", rows(x_log));
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> jacob(rows(x_log));
        stan::math::initialize(jacob, DUMMY_VAR__);
        stan::math::fill(jacob, DUMMY_VAR__);
        stan::math::assign(jacob,x_log);
        current_statement_begin__ = 14;
        local_scalar_t__ norm_constant(DUMMY_VAR__);
        (void) norm_constant;  // dummy to suppress unused var warning
        stan::math::initialize(norm_constant, DUMMY_VAR__);
        stan::math::fill(norm_constant, DUMMY_VAR__);
        stan::math::assign(norm_constant,((a * stan::math::log(b)) - stan::math::lgamma(a)));
        current_statement_begin__ = 15;
        local_scalar_t__ a_minus_1(DUMMY_VAR__);
        (void) a_minus_1;  // dummy to suppress unused var warning
        stan::math::initialize(a_minus_1, DUMMY_VAR__);
        stan::math::fill(a_minus_1, DUMMY_VAR__);
        stan::math::assign(a_minus_1,(a - 1));
        current_statement_begin__ = 16;
        return stan::math::promote_scalar<fun_return_scalar_t__>(((sum(jacob) + (norm_constant * rows(x_log))) + sum(subtract(multiply(x_log, a_minus_1), multiply(stan::math::exp(x_log), b)))));
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
template <typename T0__, typename T1__, typename T2__>
typename boost::math::tools::promote_args<T0__, T1__, T2__>::type
exp_gamma_meanSd_lpdf(const Eigen::Matrix<T0__, Eigen::Dynamic, 1>& x_log,
                          const T1__& m_log,
                          const T2__& s, std::ostream* pstream__) {
    return exp_gamma_meanSd_lpdf<false>(x_log,m_log,s, pstream__);
}
struct exp_gamma_meanSd_lpdf_functor__ {
    template <bool propto, typename T0__, typename T1__, typename T2__>
        typename boost::math::tools::promote_args<T0__, T1__, T2__>::type
    operator()(const Eigen::Matrix<T0__, Eigen::Dynamic, 1>& x_log,
                          const T1__& m_log,
                          const T2__& s, std::ostream* pstream__) const {
        return exp_gamma_meanSd_lpdf(x_log, m_log, s, pstream__);
    }
};
template <typename T0__, typename T1__, class RNG>
typename boost::math::tools::promote_args<T0__, T1__>::type
exp_gamma_meanSd_rng(const T0__& m_log,
                         const T1__& s, RNG& base_rng__, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T0__, T1__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 24;
        local_scalar_t__ m(DUMMY_VAR__);
        (void) m;  // dummy to suppress unused var warning
        stan::math::initialize(m, DUMMY_VAR__);
        stan::math::fill(m, DUMMY_VAR__);
        stan::math::assign(m,stan::math::exp(m_log));
        current_statement_begin__ = 25;
        local_scalar_t__ v(DUMMY_VAR__);
        (void) v;  // dummy to suppress unused var warning
        stan::math::initialize(v, DUMMY_VAR__);
        stan::math::fill(v, DUMMY_VAR__);
        stan::math::assign(v,(m + (square(m) * s)));
        current_statement_begin__ = 26;
        local_scalar_t__ a(DUMMY_VAR__);
        (void) a;  // dummy to suppress unused var warning
        stan::math::initialize(a, DUMMY_VAR__);
        stan::math::fill(a, DUMMY_VAR__);
        stan::math::assign(a,(square(m) / v));
        current_statement_begin__ = 27;
        local_scalar_t__ b(DUMMY_VAR__);
        (void) b;  // dummy to suppress unused var warning
        stan::math::initialize(b, DUMMY_VAR__);
        stan::math::fill(b, DUMMY_VAR__);
        stan::math::assign(b,(m / v));
        current_statement_begin__ = 29;
        return stan::math::promote_scalar<fun_return_scalar_t__>(stan::math::log(gamma_rng(a, b, base_rng__)));
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct exp_gamma_meanSd_rng_functor__ {
    template <typename T0__, typename T1__, class RNG>
        typename boost::math::tools::promote_args<T0__, T1__>::type
    operator()(const T0__& m_log,
                         const T1__& s, RNG& base_rng__, std::ostream* pstream__) const {
        return exp_gamma_meanSd_rng(m_log, s, base_rng__, pstream__);
    }
};
template <typename T4__, typename T5__, typename T6__>
std::vector<Eigen::Matrix<typename boost::math::tools::promote_args<T4__, T5__, T6__>::type, Eigen::Dynamic, 1> >
get_reference_parameters_MPI(const int& n_shards,
                                 const int& M,
                                 const std::vector<int>& G_per_shard,
                                 const std::vector<std::vector<int> >& G_ind,
                                 const Eigen::Matrix<T4__, Eigen::Dynamic, Eigen::Dynamic>& lambda_log,
                                 const Eigen::Matrix<T5__, Eigen::Dynamic, 1>& sigma,
                                 const Eigen::Matrix<T6__, Eigen::Dynamic, 1>& exposure_rate, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T4__, T5__, T6__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 34;
        int S(0);
        (void) S;  // dummy to suppress unused var warning
        stan::math::fill(S, std::numeric_limits<int>::min());
        stan::math::assign(S,rows(exposure_rate));
        current_statement_begin__ = 35;
        validate_non_negative_index("lambda_sigma_exposure_MPI", "(((M * S) + M) + S)", (((M * S) + M) + S));
        validate_non_negative_index("lambda_sigma_exposure_MPI", "n_shards", n_shards);
        std::vector<Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1>  > lambda_sigma_exposure_MPI(n_shards, Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1>((((M * S) + M) + S)));
        stan::math::initialize(lambda_sigma_exposure_MPI, DUMMY_VAR__);
        stan::math::fill(lambda_sigma_exposure_MPI, DUMMY_VAR__);
        current_statement_begin__ = 37;
        for (int i = 1; i <= n_shards; ++i) {
            {
            current_statement_begin__ = 39;
            int size_buffer(0);
            (void) size_buffer;  // dummy to suppress unused var warning
            stan::math::fill(size_buffer, std::numeric_limits<int>::min());
            stan::math::assign(size_buffer,(((M * S) + M) - ((get_base1(G_per_shard, i, "G_per_shard", 1) * S) + get_base1(G_per_shard, i, "G_per_shard", 1))));
            current_statement_begin__ = 40;
            validate_non_negative_index("buffer", "size_buffer", size_buffer);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> buffer(size_buffer);
            stan::math::initialize(buffer, DUMMY_VAR__);
            stan::math::fill(buffer, DUMMY_VAR__);
            stan::math::assign(buffer,rep_vector(0.0, size_buffer));
            current_statement_begin__ = 42;
            stan::model::assign(lambda_sigma_exposure_MPI, 
                        stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list()), 
                        append_row(append_row(append_row(to_vector(stan::model::rvalue(lambda_log, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_multi(stan::model::rvalue(G_ind, stan::model::cons_list(stan::model::index_uni(i), stan::model::cons_list(stan::model::index_min_max(1, get_base1(G_per_shard, i, "G_per_shard", 1)), stan::model::nil_index_list())), "G_ind")), stan::model::nil_index_list())), "lambda_log")), stan::model::rvalue(sigma, stan::model::cons_list(stan::model::index_multi(stan::model::rvalue(G_ind, stan::model::cons_list(stan::model::index_uni(i), stan::model::cons_list(stan::model::index_min_max(1, get_base1(G_per_shard, i, "G_per_shard", 1)), stan::model::nil_index_list())), "G_ind")), stan::model::nil_index_list()), "sigma")), buffer), exposure_rate), 
                        "assigning variable lambda_sigma_exposure_MPI");
            }
        }
        current_statement_begin__ = 55;
        return stan::math::promote_scalar<fun_return_scalar_t__>(lambda_sigma_exposure_MPI);
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct get_reference_parameters_MPI_functor__ {
    template <typename T4__, typename T5__, typename T6__>
        std::vector<Eigen::Matrix<typename boost::math::tools::promote_args<T4__, T5__, T6__>::type, Eigen::Dynamic, 1> >
    operator()(const int& n_shards,
                                 const int& M,
                                 const std::vector<int>& G_per_shard,
                                 const std::vector<std::vector<int> >& G_ind,
                                 const Eigen::Matrix<T4__, Eigen::Dynamic, Eigen::Dynamic>& lambda_log,
                                 const Eigen::Matrix<T5__, Eigen::Dynamic, 1>& sigma,
                                 const Eigen::Matrix<T6__, Eigen::Dynamic, 1>& exposure_rate, std::ostream* pstream__) const {
        return get_reference_parameters_MPI(n_shards, M, G_per_shard, G_ind, lambda_log, sigma, exposure_rate, pstream__);
    }
};
template <typename T0__, typename T1__, typename T2__>
Eigen::Matrix<typename boost::math::tools::promote_args<T0__, T1__, T2__>::type, Eigen::Dynamic, 1>
lp_reduce(const Eigen::Matrix<T0__, Eigen::Dynamic, 1>& global_parameters,
              const Eigen::Matrix<T1__, Eigen::Dynamic, 1>& local_parameters,
              const std::vector<T2__>& real_data,
              const std::vector<int>& int_data, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T0__, T1__, T2__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 60;
        local_scalar_t__ lp(DUMMY_VAR__);
        (void) lp;  // dummy to suppress unused var warning
        stan::math::initialize(lp, DUMMY_VAR__);
        stan::math::fill(lp, DUMMY_VAR__);
        current_statement_begin__ = 63;
        int M(0);
        (void) M;  // dummy to suppress unused var warning
        stan::math::fill(M, std::numeric_limits<int>::min());
        stan::math::assign(M,get_base1(int_data, 1, "int_data", 1));
        current_statement_begin__ = 64;
        int N(0);
        (void) N;  // dummy to suppress unused var warning
        stan::math::fill(N, std::numeric_limits<int>::min());
        stan::math::assign(N,get_base1(int_data, 2, "int_data", 1));
        current_statement_begin__ = 65;
        int S(0);
        (void) S;  // dummy to suppress unused var warning
        stan::math::fill(S, std::numeric_limits<int>::min());
        stan::math::assign(S,get_base1(int_data, 3, "int_data", 1));
        current_statement_begin__ = 66;
        int G_per_shard(0);
        (void) G_per_shard;  // dummy to suppress unused var warning
        stan::math::fill(G_per_shard, std::numeric_limits<int>::min());
        stan::math::assign(G_per_shard,get_base1(int_data, 4, "int_data", 1));
        current_statement_begin__ = 67;
        validate_non_negative_index("symbol_end", "(M + 1)", (M + 1));
        std::vector<int  > symbol_end((M + 1), int(0));
        stan::math::fill(symbol_end, std::numeric_limits<int>::min());
        stan::math::assign(symbol_end,stan::model::rvalue(int_data, stan::model::cons_list(stan::model::index_min_max((4 + 1), ((4 + 1) + M)), stan::model::nil_index_list()), "int_data"));
        current_statement_begin__ = 68;
        validate_non_negative_index("sample_idx", "N", N);
        std::vector<int  > sample_idx(N, int(0));
        stan::math::fill(sample_idx, std::numeric_limits<int>::min());
        stan::math::assign(sample_idx,stan::model::rvalue(int_data, stan::model::cons_list(stan::model::index_min_max((((4 + 1) + M) + 1), (((((4 + 1) + M) + 1) + N) - 1)), stan::model::nil_index_list()), "int_data"));
        current_statement_begin__ = 69;
        validate_non_negative_index("counts", "N", N);
        std::vector<int  > counts(N, int(0));
        stan::math::fill(counts, std::numeric_limits<int>::min());
        stan::math::assign(counts,stan::model::rvalue(int_data, stan::model::cons_list(stan::model::index_min_max(((((((4 + 1) + M) + 1) + N) - 1) + 1), ((((((4 + 1) + M) + 1) + N) - 1) + N)), stan::model::nil_index_list()), "int_data"));
        current_statement_begin__ = 72;
        int size_exclude(0);
        (void) size_exclude;  // dummy to suppress unused var warning
        stan::math::fill(size_exclude, std::numeric_limits<int>::min());
        stan::math::assign(size_exclude,get_base1(int_data, (((((((4 + 1) + M) + 1) + N) - 1) + N) + 1), "int_data", 1));
        current_statement_begin__ = 73;
        validate_non_negative_index("to_exclude", "size_exclude", size_exclude);
        std::vector<int  > to_exclude(size_exclude, int(0));
        stan::math::fill(to_exclude, std::numeric_limits<int>::min());
        stan::math::assign(to_exclude,stan::model::rvalue(int_data, stan::model::cons_list(stan::model::index_min_max(((((((((4 + 1) + M) + 1) + N) - 1) + N) + 1) + 1), ((((((((4 + 1) + M) + 1) + N) - 1) + N) + 1) + size_exclude)), stan::model::nil_index_list()), "int_data"));
        current_statement_begin__ = 76;
        validate_non_negative_index("lambda_MPI", "(G_per_shard * S)", (G_per_shard * S));
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> lambda_MPI((G_per_shard * S));
        stan::math::initialize(lambda_MPI, DUMMY_VAR__);
        stan::math::fill(lambda_MPI, DUMMY_VAR__);
        stan::math::assign(lambda_MPI,stan::model::rvalue(local_parameters, stan::model::cons_list(stan::model::index_min_max(1, (G_per_shard * S)), stan::model::nil_index_list()), "local_parameters"));
        current_statement_begin__ = 77;
        validate_non_negative_index("sigma_MPI", "G_per_shard", G_per_shard);
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> sigma_MPI(G_per_shard);
        stan::math::initialize(sigma_MPI, DUMMY_VAR__);
        stan::math::fill(sigma_MPI, DUMMY_VAR__);
        stan::math::assign(sigma_MPI,stan::model::rvalue(local_parameters, stan::model::cons_list(stan::model::index_min_max(((G_per_shard * S) + 1), ((G_per_shard * S) + G_per_shard)), stan::model::nil_index_list()), "local_parameters"));
        current_statement_begin__ = 78;
        validate_non_negative_index("exposure_rate", "S", S);
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> exposure_rate(S);
        stan::math::initialize(exposure_rate, DUMMY_VAR__);
        stan::math::fill(exposure_rate, DUMMY_VAR__);
        stan::math::assign(exposure_rate,stan::model::rvalue(local_parameters, stan::model::cons_list(stan::model::index_min_max((((M * S) + M) + 1), rows(local_parameters)), stan::model::nil_index_list()), "local_parameters"));
        current_statement_begin__ = 82;
        validate_non_negative_index("sigma_MPI_c", "get_base1(symbol_end, (G_per_shard + 1), \"symbol_end\", 1)", get_base1(symbol_end, (G_per_shard + 1), "symbol_end", 1));
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> sigma_MPI_c(get_base1(symbol_end, (G_per_shard + 1), "symbol_end", 1));
        stan::math::initialize(sigma_MPI_c, DUMMY_VAR__);
        stan::math::fill(sigma_MPI_c, DUMMY_VAR__);
        current_statement_begin__ = 91;
        for (int g = 1; g <= G_per_shard; ++g) {
            {
            current_statement_begin__ = 92;
            int how_many(0);
            (void) how_many;  // dummy to suppress unused var warning
            stan::math::fill(how_many, std::numeric_limits<int>::min());
            stan::math::assign(how_many,(get_base1(symbol_end, (g + 1), "symbol_end", 1) - get_base1(symbol_end, g, "symbol_end", 1)));
            current_statement_begin__ = 94;
            stan::model::assign(sigma_MPI_c, 
                        stan::model::cons_list(stan::model::index_min_max((get_base1(symbol_end, g, "symbol_end", 1) + 1), get_base1(symbol_end, (g + 1), "symbol_end", 1)), stan::model::nil_index_list()), 
                        rep_vector(get_base1(sigma_MPI, g, "sigma_MPI", 1), how_many), 
                        "assigning variable sigma_MPI_c");
            }
        }
        current_statement_begin__ = 97;
        stan::math::assign(lp, (neg_binomial_2_log_log(stan::model::rvalue(counts, stan::model::cons_list(stan::model::index_min_max(1, get_base1(symbol_end, (G_per_shard + 1), "symbol_end", 1)), stan::model::nil_index_list()), "counts"), add(stan::model::rvalue(exposure_rate, stan::model::cons_list(stan::model::index_multi(stan::model::rvalue(sample_idx, stan::model::cons_list(stan::model::index_min_max(1, get_base1(symbol_end, (G_per_shard + 1), "symbol_end", 1)), stan::model::nil_index_list()), "sample_idx")), stan::model::nil_index_list()), "exposure_rate"), lambda_MPI), sigma_MPI_c) - (logical_gt(size_exclude, 0) ? stan::math::promote_scalar<local_scalar_t__>(neg_binomial_2_log_log(stan::model::rvalue(stan::model::rvalue(counts, stan::model::cons_list(stan::model::index_min_max(1, get_base1(symbol_end, (G_per_shard + 1), "symbol_end", 1)), stan::model::nil_index_list()), "counts"), stan::model::cons_list(stan::model::index_multi(to_exclude), stan::model::nil_index_list()), "counts[1:symbol_end[(G_per_shard + 1)]]"), add(stan::model::rvalue(stan::model::rvalue(exposure_rate, stan::model::cons_list(stan::model::index_multi(stan::model::rvalue(sample_idx, stan::model::cons_list(stan::model::index_min_max(1, get_base1(symbol_end, (G_per_shard + 1), "symbol_end", 1)), stan::model::nil_index_list()), "sample_idx")), stan::model::nil_index_list()), "exposure_rate"), stan::model::cons_list(stan::model::index_multi(to_exclude), stan::model::nil_index_list()), "exposure_rate[sample_idx[1:symbol_end[(G_per_shard + 1)]]]"), stan::model::rvalue(lambda_MPI, stan::model::cons_list(stan::model::index_multi(to_exclude), stan::model::nil_index_list()), "lambda_MPI")), stan::model::rvalue(sigma_MPI_c, stan::model::cons_list(stan::model::index_multi(to_exclude), stan::model::nil_index_list()), "sigma_MPI_c"))) : stan::math::promote_scalar<local_scalar_t__>(0) )));
        current_statement_begin__ = 118;
        return stan::math::promote_scalar<fun_return_scalar_t__>(transpose(stan::math::to_row_vector(stan::math::array_builder<local_scalar_t__ >().add(lp).array())));
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct lp_reduce_functor__ {
    template <typename T0__, typename T1__, typename T2__>
        Eigen::Matrix<typename boost::math::tools::promote_args<T0__, T1__, T2__>::type, Eigen::Dynamic, 1>
    operator()(const Eigen::Matrix<T0__, Eigen::Dynamic, 1>& global_parameters,
              const Eigen::Matrix<T1__, Eigen::Dynamic, 1>& local_parameters,
              const std::vector<T2__>& real_data,
              const std::vector<int>& int_data, std::ostream* pstream__) const {
        return lp_reduce(global_parameters, local_parameters, real_data, int_data, pstream__);
    }
};
template <typename T0__, typename T1__, typename T2__>
Eigen::Matrix<typename boost::math::tools::promote_args<T0__, T1__, T2__>::type, Eigen::Dynamic, Eigen::Dynamic>
merge_coefficients(const Eigen::Matrix<T0__, 1, Eigen::Dynamic>& intercept,
                       const Eigen::Matrix<T1__, 1, Eigen::Dynamic>& alpha_sub_1,
                       const Eigen::Matrix<T2__, Eigen::Dynamic, Eigen::Dynamic>& alpha_2,
                       const int& C,
                       const int& S,
                       const int& G, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T0__, T1__, T2__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 123;
        validate_non_negative_index("my_alpha", "C", C);
        validate_non_negative_index("my_alpha", "G", G);
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> my_alpha(C, G);
        stan::math::initialize(my_alpha, DUMMY_VAR__);
        stan::math::fill(my_alpha, DUMMY_VAR__);
        current_statement_begin__ = 126;
        if (as_bool(logical_eq(C, 1))) {
            current_statement_begin__ = 127;
            stan::math::assign(my_alpha, to_matrix(intercept));
        } else if (as_bool(logical_gt(C, 1))) {
            current_statement_begin__ = 129;
            stan::math::assign(my_alpha, append_row(append_row(intercept, append_col(alpha_sub_1, rep_row_vector(0.0, (G - cols(alpha_sub_1))))), append_col(alpha_2, rep_matrix(0.0, rows(alpha_2), (G - cols(alpha_2))))));
        }
        current_statement_begin__ = 138;
        return stan::math::promote_scalar<fun_return_scalar_t__>(my_alpha);
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct merge_coefficients_functor__ {
    template <typename T0__, typename T1__, typename T2__>
        Eigen::Matrix<typename boost::math::tools::promote_args<T0__, T1__, T2__>::type, Eigen::Dynamic, Eigen::Dynamic>
    operator()(const Eigen::Matrix<T0__, 1, Eigen::Dynamic>& intercept,
                       const Eigen::Matrix<T1__, 1, Eigen::Dynamic>& alpha_sub_1,
                       const Eigen::Matrix<T2__, Eigen::Dynamic, Eigen::Dynamic>& alpha_2,
                       const int& C,
                       const int& S,
                       const int& G, std::ostream* pstream__) const {
        return merge_coefficients(intercept, alpha_sub_1, alpha_2, C, S, G, pstream__);
    }
};
#include <stan_meta_header.hpp>
class model_negBinomial_MPI
  : public stan::model::model_base_crtp<model_negBinomial_MPI> {
private:
        int N;
        int M;
        int G;
        int S;
        int n_shards;
        std::vector<std::vector<int> > counts;
        std::vector<std::vector<int> > symbol_end;
        std::vector<std::vector<int> > G_ind;
        std::vector<std::vector<int> > sample_idx;
        std::vector<int> G_per_shard;
        std::vector<int> G_per_shard_idx;
        int CP;
        std::vector<std::vector<int> > counts_package;
        int C;
        matrix_d X;
        double lambda_mu_mu;
        int how_many_to_check;
        double exposure_rate_multiplier;
        std::vector<double> intercept_shift_scale;
        double truncation_compensation;
        vector_d global_parameters;
        std::vector<std::vector<double> > real_data;
public:
    model_negBinomial_MPI(stan::io::var_context& context__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, 0, pstream__);
    }
    model_negBinomial_MPI(stan::io::var_context& context__,
        unsigned int random_seed__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, random_seed__, pstream__);
    }
    void ctor_body(stan::io::var_context& context__,
                   unsigned int random_seed__,
                   std::ostream* pstream__) {
        typedef double local_scalar_t__;
        boost::ecuyer1988 base_rng__ =
          stan::services::util::create_rng(random_seed__, 0);
        (void) base_rng__;  // suppress unused var warning
        current_statement_begin__ = -1;
        static const char* function__ = "model_negBinomial_MPI_namespace::model_negBinomial_MPI";
        (void) function__;  // dummy to suppress unused var warning
        size_t pos__;
        (void) pos__;  // dummy to suppress unused var warning
        std::vector<int> vals_i__;
        std::vector<double> vals_r__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        try {
            // initialize data block variables from context__
            current_statement_begin__ = 145;
            context__.validate_dims("data initialization", "N", "int", context__.to_vec());
            N = int(0);
            vals_i__ = context__.vals_i("N");
            pos__ = 0;
            N = vals_i__[pos__++];
            check_greater_or_equal(function__, "N", N, 0);
            current_statement_begin__ = 146;
            context__.validate_dims("data initialization", "M", "int", context__.to_vec());
            M = int(0);
            vals_i__ = context__.vals_i("M");
            pos__ = 0;
            M = vals_i__[pos__++];
            check_greater_or_equal(function__, "M", M, 0);
            current_statement_begin__ = 147;
            context__.validate_dims("data initialization", "G", "int", context__.to_vec());
            G = int(0);
            vals_i__ = context__.vals_i("G");
            pos__ = 0;
            G = vals_i__[pos__++];
            check_greater_or_equal(function__, "G", G, 0);
            current_statement_begin__ = 148;
            context__.validate_dims("data initialization", "S", "int", context__.to_vec());
            S = int(0);
            vals_i__ = context__.vals_i("S");
            pos__ = 0;
            S = vals_i__[pos__++];
            check_greater_or_equal(function__, "S", S, 0);
            current_statement_begin__ = 149;
            context__.validate_dims("data initialization", "n_shards", "int", context__.to_vec());
            n_shards = int(0);
            vals_i__ = context__.vals_i("n_shards");
            pos__ = 0;
            n_shards = vals_i__[pos__++];
            current_statement_begin__ = 150;
            validate_non_negative_index("counts", "n_shards", n_shards);
            validate_non_negative_index("counts", "N", N);
            context__.validate_dims("data initialization", "counts", "int", context__.to_vec(n_shards,N));
            counts = std::vector<std::vector<int> >(n_shards, std::vector<int>(N, int(0)));
            vals_i__ = context__.vals_i("counts");
            pos__ = 0;
            size_t counts_k_0_max__ = n_shards;
            size_t counts_k_1_max__ = N;
            for (size_t k_1__ = 0; k_1__ < counts_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < counts_k_0_max__; ++k_0__) {
                    counts[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            size_t counts_i_0_max__ = n_shards;
            size_t counts_i_1_max__ = N;
            for (size_t i_0__ = 0; i_0__ < counts_i_0_max__; ++i_0__) {
                for (size_t i_1__ = 0; i_1__ < counts_i_1_max__; ++i_1__) {
                    check_greater_or_equal(function__, "counts[i_0__][i_1__]", counts[i_0__][i_1__], 0);
                }
            }
            current_statement_begin__ = 151;
            validate_non_negative_index("symbol_end", "n_shards", n_shards);
            validate_non_negative_index("symbol_end", "(M + 1)", (M + 1));
            context__.validate_dims("data initialization", "symbol_end", "int", context__.to_vec(n_shards,(M + 1)));
            symbol_end = std::vector<std::vector<int> >(n_shards, std::vector<int>((M + 1), int(0)));
            vals_i__ = context__.vals_i("symbol_end");
            pos__ = 0;
            size_t symbol_end_k_0_max__ = n_shards;
            size_t symbol_end_k_1_max__ = (M + 1);
            for (size_t k_1__ = 0; k_1__ < symbol_end_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < symbol_end_k_0_max__; ++k_0__) {
                    symbol_end[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            size_t symbol_end_i_0_max__ = n_shards;
            size_t symbol_end_i_1_max__ = (M + 1);
            for (size_t i_0__ = 0; i_0__ < symbol_end_i_0_max__; ++i_0__) {
                for (size_t i_1__ = 0; i_1__ < symbol_end_i_1_max__; ++i_1__) {
                    check_greater_or_equal(function__, "symbol_end[i_0__][i_1__]", symbol_end[i_0__][i_1__], 0);
                }
            }
            current_statement_begin__ = 152;
            validate_non_negative_index("G_ind", "n_shards", n_shards);
            validate_non_negative_index("G_ind", "M", M);
            context__.validate_dims("data initialization", "G_ind", "int", context__.to_vec(n_shards,M));
            G_ind = std::vector<std::vector<int> >(n_shards, std::vector<int>(M, int(0)));
            vals_i__ = context__.vals_i("G_ind");
            pos__ = 0;
            size_t G_ind_k_0_max__ = n_shards;
            size_t G_ind_k_1_max__ = M;
            for (size_t k_1__ = 0; k_1__ < G_ind_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < G_ind_k_0_max__; ++k_0__) {
                    G_ind[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            size_t G_ind_i_0_max__ = n_shards;
            size_t G_ind_i_1_max__ = M;
            for (size_t i_0__ = 0; i_0__ < G_ind_i_0_max__; ++i_0__) {
                for (size_t i_1__ = 0; i_1__ < G_ind_i_1_max__; ++i_1__) {
                    check_greater_or_equal(function__, "G_ind[i_0__][i_1__]", G_ind[i_0__][i_1__], 0);
                }
            }
            current_statement_begin__ = 153;
            validate_non_negative_index("sample_idx", "n_shards", n_shards);
            validate_non_negative_index("sample_idx", "N", N);
            context__.validate_dims("data initialization", "sample_idx", "int", context__.to_vec(n_shards,N));
            sample_idx = std::vector<std::vector<int> >(n_shards, std::vector<int>(N, int(0)));
            vals_i__ = context__.vals_i("sample_idx");
            pos__ = 0;
            size_t sample_idx_k_0_max__ = n_shards;
            size_t sample_idx_k_1_max__ = N;
            for (size_t k_1__ = 0; k_1__ < sample_idx_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < sample_idx_k_0_max__; ++k_0__) {
                    sample_idx[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            size_t sample_idx_i_0_max__ = n_shards;
            size_t sample_idx_i_1_max__ = N;
            for (size_t i_0__ = 0; i_0__ < sample_idx_i_0_max__; ++i_0__) {
                for (size_t i_1__ = 0; i_1__ < sample_idx_i_1_max__; ++i_1__) {
                    check_greater_or_equal(function__, "sample_idx[i_0__][i_1__]", sample_idx[i_0__][i_1__], 0);
                }
            }
            current_statement_begin__ = 154;
            validate_non_negative_index("G_per_shard", "n_shards", n_shards);
            context__.validate_dims("data initialization", "G_per_shard", "int", context__.to_vec(n_shards));
            G_per_shard = std::vector<int>(n_shards, int(0));
            vals_i__ = context__.vals_i("G_per_shard");
            pos__ = 0;
            size_t G_per_shard_k_0_max__ = n_shards;
            for (size_t k_0__ = 0; k_0__ < G_per_shard_k_0_max__; ++k_0__) {
                G_per_shard[k_0__] = vals_i__[pos__++];
            }
            size_t G_per_shard_i_0_max__ = n_shards;
            for (size_t i_0__ = 0; i_0__ < G_per_shard_i_0_max__; ++i_0__) {
                check_greater_or_equal(function__, "G_per_shard[i_0__]", G_per_shard[i_0__], 0);
            }
            current_statement_begin__ = 155;
            validate_non_negative_index("G_per_shard_idx", "(n_shards + 1)", (n_shards + 1));
            context__.validate_dims("data initialization", "G_per_shard_idx", "int", context__.to_vec((n_shards + 1)));
            G_per_shard_idx = std::vector<int>((n_shards + 1), int(0));
            vals_i__ = context__.vals_i("G_per_shard_idx");
            pos__ = 0;
            size_t G_per_shard_idx_k_0_max__ = (n_shards + 1);
            for (size_t k_0__ = 0; k_0__ < G_per_shard_idx_k_0_max__; ++k_0__) {
                G_per_shard_idx[k_0__] = vals_i__[pos__++];
            }
            size_t G_per_shard_idx_i_0_max__ = (n_shards + 1);
            for (size_t i_0__ = 0; i_0__ < G_per_shard_idx_i_0_max__; ++i_0__) {
                check_greater_or_equal(function__, "G_per_shard_idx[i_0__]", G_per_shard_idx[i_0__], 0);
            }
            current_statement_begin__ = 157;
            context__.validate_dims("data initialization", "CP", "int", context__.to_vec());
            CP = int(0);
            vals_i__ = context__.vals_i("CP");
            pos__ = 0;
            CP = vals_i__[pos__++];
            check_greater_or_equal(function__, "CP", CP, 0);
            current_statement_begin__ = 158;
            validate_non_negative_index("counts_package", "n_shards", n_shards);
            validate_non_negative_index("counts_package", "CP", CP);
            context__.validate_dims("data initialization", "counts_package", "int", context__.to_vec(n_shards,CP));
            counts_package = std::vector<std::vector<int> >(n_shards, std::vector<int>(CP, int(0)));
            vals_i__ = context__.vals_i("counts_package");
            pos__ = 0;
            size_t counts_package_k_0_max__ = n_shards;
            size_t counts_package_k_1_max__ = CP;
            for (size_t k_1__ = 0; k_1__ < counts_package_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < counts_package_k_0_max__; ++k_0__) {
                    counts_package[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            size_t counts_package_i_0_max__ = n_shards;
            size_t counts_package_i_1_max__ = CP;
            for (size_t i_0__ = 0; i_0__ < counts_package_i_0_max__; ++i_0__) {
                for (size_t i_1__ = 0; i_1__ < counts_package_i_1_max__; ++i_1__) {
                    check_greater_or_equal(function__, "counts_package[i_0__][i_1__]", counts_package[i_0__][i_1__], 0);
                }
            }
            current_statement_begin__ = 160;
            context__.validate_dims("data initialization", "C", "int", context__.to_vec());
            C = int(0);
            vals_i__ = context__.vals_i("C");
            pos__ = 0;
            C = vals_i__[pos__++];
            check_greater_or_equal(function__, "C", C, 1);
            current_statement_begin__ = 161;
            validate_non_negative_index("X", "S", S);
            validate_non_negative_index("X", "C", C);
            context__.validate_dims("data initialization", "X", "matrix_d", context__.to_vec(S,C));
            X = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(S, C);
            vals_r__ = context__.vals_r("X");
            pos__ = 0;
            size_t X_j_2_max__ = C;
            size_t X_j_1_max__ = S;
            for (size_t j_2__ = 0; j_2__ < X_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < X_j_1_max__; ++j_1__) {
                    X(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 163;
            context__.validate_dims("data initialization", "lambda_mu_mu", "double", context__.to_vec());
            lambda_mu_mu = double(0);
            vals_r__ = context__.vals_r("lambda_mu_mu");
            pos__ = 0;
            lambda_mu_mu = vals_r__[pos__++];
            check_greater_or_equal(function__, "lambda_mu_mu", lambda_mu_mu, 0);
            current_statement_begin__ = 165;
            context__.validate_dims("data initialization", "how_many_to_check", "int", context__.to_vec());
            how_many_to_check = int(0);
            vals_i__ = context__.vals_i("how_many_to_check");
            pos__ = 0;
            how_many_to_check = vals_i__[pos__++];
            check_greater_or_equal(function__, "how_many_to_check", how_many_to_check, 0);
            current_statement_begin__ = 168;
            context__.validate_dims("data initialization", "exposure_rate_multiplier", "double", context__.to_vec());
            exposure_rate_multiplier = double(0);
            vals_r__ = context__.vals_r("exposure_rate_multiplier");
            pos__ = 0;
            exposure_rate_multiplier = vals_r__[pos__++];
            current_statement_begin__ = 169;
            validate_non_negative_index("intercept_shift_scale", "2", 2);
            context__.validate_dims("data initialization", "intercept_shift_scale", "double", context__.to_vec(2));
            intercept_shift_scale = std::vector<double>(2, double(0));
            vals_r__ = context__.vals_r("intercept_shift_scale");
            pos__ = 0;
            size_t intercept_shift_scale_k_0_max__ = 2;
            for (size_t k_0__ = 0; k_0__ < intercept_shift_scale_k_0_max__; ++k_0__) {
                intercept_shift_scale[k_0__] = vals_r__[pos__++];
            }
            current_statement_begin__ = 172;
            context__.validate_dims("data initialization", "truncation_compensation", "double", context__.to_vec());
            truncation_compensation = double(0);
            vals_r__ = context__.vals_r("truncation_compensation");
            pos__ = 0;
            truncation_compensation = vals_r__[pos__++];
            check_greater_or_equal(function__, "truncation_compensation", truncation_compensation, 0);
            // initialize transformed data variables
            current_statement_begin__ = 177;
            validate_non_negative_index("global_parameters", "0", 0);
            global_parameters = Eigen::Matrix<double, Eigen::Dynamic, 1>(0);
            stan::math::fill(global_parameters, DUMMY_VAR__);
            current_statement_begin__ = 178;
            validate_non_negative_index("real_data", "n_shards", n_shards);
            validate_non_negative_index("real_data", "0", 0);
            real_data = std::vector<std::vector<double> >(n_shards, std::vector<double>(0, double(0)));
            stan::math::fill(real_data, DUMMY_VAR__);
            // execute transformed data statements
            // validate transformed data
            // validate, set parameter ranges
            num_params_r__ = 0U;
            param_ranges_i__.clear();
            current_statement_begin__ = 184;
            num_params_r__ += 1;
            current_statement_begin__ = 185;
            num_params_r__ += 1;
            current_statement_begin__ = 186;
            num_params_r__ += 1;
            current_statement_begin__ = 188;
            validate_non_negative_index("exposure_rate", "S", S);
            num_params_r__ += S;
            current_statement_begin__ = 191;
            validate_non_negative_index("intercept", "G", G);
            num_params_r__ += G;
            current_statement_begin__ = 192;
            validate_non_negative_index("alpha_sub_1", "how_many_to_check", how_many_to_check);
            num_params_r__ += how_many_to_check;
            current_statement_begin__ = 193;
            validate_non_negative_index("alpha_2", "std::max(0, (C - 2))", std::max(0, (C - 2)));
            validate_non_negative_index("alpha_2", "how_many_to_check", how_many_to_check);
            num_params_r__ += (std::max(0, (C - 2)) * how_many_to_check);
            current_statement_begin__ = 194;
            validate_non_negative_index("sigma_raw", "G", G);
            num_params_r__ += G;
            current_statement_begin__ = 198;
            num_params_r__ += 1;
            current_statement_begin__ = 199;
            num_params_r__ += 1;
            current_statement_begin__ = 200;
            num_params_r__ += 1;
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    ~model_negBinomial_MPI() { }
    void transform_inits(const stan::io::var_context& context__,
                         std::vector<int>& params_i__,
                         std::vector<double>& params_r__,
                         std::ostream* pstream__) const {
        typedef double local_scalar_t__;
        stan::io::writer<double> writer__(params_r__, params_i__);
        size_t pos__;
        (void) pos__; // dummy call to supress warning
        std::vector<double> vals_r__;
        std::vector<int> vals_i__;
        current_statement_begin__ = 184;
        if (!(context__.contains_r("lambda_mu")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable lambda_mu missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("lambda_mu");
        pos__ = 0U;
        context__.validate_dims("parameter initialization", "lambda_mu", "double", context__.to_vec());
        double lambda_mu(0);
        lambda_mu = vals_r__[pos__++];
        try {
            writer__.scalar_offset_multiplier_unconstrain(lambda_mu_mu, 1, lambda_mu);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable lambda_mu: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 185;
        if (!(context__.contains_r("lambda_sigma")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable lambda_sigma missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("lambda_sigma");
        pos__ = 0U;
        context__.validate_dims("parameter initialization", "lambda_sigma", "double", context__.to_vec());
        double lambda_sigma(0);
        lambda_sigma = vals_r__[pos__++];
        try {
            writer__.scalar_lb_unconstrain(0, lambda_sigma);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable lambda_sigma: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 186;
        if (!(context__.contains_r("lambda_skew")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable lambda_skew missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("lambda_skew");
        pos__ = 0U;
        context__.validate_dims("parameter initialization", "lambda_skew", "double", context__.to_vec());
        double lambda_skew(0);
        lambda_skew = vals_r__[pos__++];
        try {
            writer__.scalar_unconstrain(lambda_skew);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable lambda_skew: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 188;
        if (!(context__.contains_r("exposure_rate")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable exposure_rate missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("exposure_rate");
        pos__ = 0U;
        validate_non_negative_index("exposure_rate", "S", S);
        context__.validate_dims("parameter initialization", "exposure_rate", "vector_d", context__.to_vec(S));
        Eigen::Matrix<double, Eigen::Dynamic, 1> exposure_rate(S);
        size_t exposure_rate_j_1_max__ = S;
        for (size_t j_1__ = 0; j_1__ < exposure_rate_j_1_max__; ++j_1__) {
            exposure_rate(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.vector_offset_multiplier_unconstrain(0, exposure_rate_multiplier, exposure_rate);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable exposure_rate: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 191;
        if (!(context__.contains_r("intercept")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable intercept missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("intercept");
        pos__ = 0U;
        validate_non_negative_index("intercept", "G", G);
        context__.validate_dims("parameter initialization", "intercept", "row_vector_d", context__.to_vec(G));
        Eigen::Matrix<double, 1, Eigen::Dynamic> intercept(G);
        size_t intercept_j_1_max__ = G;
        for (size_t j_1__ = 0; j_1__ < intercept_j_1_max__; ++j_1__) {
            intercept(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.row_vector_unconstrain(intercept);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable intercept: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 192;
        if (!(context__.contains_r("alpha_sub_1")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable alpha_sub_1 missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("alpha_sub_1");
        pos__ = 0U;
        validate_non_negative_index("alpha_sub_1", "how_many_to_check", how_many_to_check);
        context__.validate_dims("parameter initialization", "alpha_sub_1", "row_vector_d", context__.to_vec(how_many_to_check));
        Eigen::Matrix<double, 1, Eigen::Dynamic> alpha_sub_1(how_many_to_check);
        size_t alpha_sub_1_j_1_max__ = how_many_to_check;
        for (size_t j_1__ = 0; j_1__ < alpha_sub_1_j_1_max__; ++j_1__) {
            alpha_sub_1(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.row_vector_unconstrain(alpha_sub_1);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable alpha_sub_1: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 193;
        if (!(context__.contains_r("alpha_2")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable alpha_2 missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("alpha_2");
        pos__ = 0U;
        validate_non_negative_index("alpha_2", "std::max(0, (C - 2))", std::max(0, (C - 2)));
        validate_non_negative_index("alpha_2", "how_many_to_check", how_many_to_check);
        context__.validate_dims("parameter initialization", "alpha_2", "matrix_d", context__.to_vec(std::max(0, (C - 2)),how_many_to_check));
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> alpha_2(std::max(0, (C - 2)), how_many_to_check);
        size_t alpha_2_j_2_max__ = how_many_to_check;
        size_t alpha_2_j_1_max__ = std::max(0, (C - 2));
        for (size_t j_2__ = 0; j_2__ < alpha_2_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_2_j_1_max__; ++j_1__) {
                alpha_2(j_1__, j_2__) = vals_r__[pos__++];
            }
        }
        try {
            writer__.matrix_unconstrain(alpha_2);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable alpha_2: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 194;
        if (!(context__.contains_r("sigma_raw")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable sigma_raw missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("sigma_raw");
        pos__ = 0U;
        validate_non_negative_index("sigma_raw", "G", G);
        context__.validate_dims("parameter initialization", "sigma_raw", "vector_d", context__.to_vec(G));
        Eigen::Matrix<double, Eigen::Dynamic, 1> sigma_raw(G);
        size_t sigma_raw_j_1_max__ = G;
        for (size_t j_1__ = 0; j_1__ < sigma_raw_j_1_max__; ++j_1__) {
            sigma_raw(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.vector_unconstrain(sigma_raw);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable sigma_raw: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 198;
        if (!(context__.contains_r("sigma_slope")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable sigma_slope missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("sigma_slope");
        pos__ = 0U;
        context__.validate_dims("parameter initialization", "sigma_slope", "double", context__.to_vec());
        double sigma_slope(0);
        sigma_slope = vals_r__[pos__++];
        try {
            writer__.scalar_ub_unconstrain(0, sigma_slope);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable sigma_slope: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 199;
        if (!(context__.contains_r("sigma_intercept")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable sigma_intercept missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("sigma_intercept");
        pos__ = 0U;
        context__.validate_dims("parameter initialization", "sigma_intercept", "double", context__.to_vec());
        double sigma_intercept(0);
        sigma_intercept = vals_r__[pos__++];
        try {
            writer__.scalar_unconstrain(sigma_intercept);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable sigma_intercept: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 200;
        if (!(context__.contains_r("sigma_sigma")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable sigma_sigma missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("sigma_sigma");
        pos__ = 0U;
        context__.validate_dims("parameter initialization", "sigma_sigma", "double", context__.to_vec());
        double sigma_sigma(0);
        sigma_sigma = vals_r__[pos__++];
        try {
            writer__.scalar_lb_unconstrain(0, sigma_sigma);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable sigma_sigma: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        params_r__ = writer__.data_r();
        params_i__ = writer__.data_i();
    }
    void transform_inits(const stan::io::var_context& context,
                         Eigen::Matrix<double, Eigen::Dynamic, 1>& params_r,
                         std::ostream* pstream__) const {
      std::vector<double> params_r_vec;
      std::vector<int> params_i_vec;
      transform_inits(context, params_i_vec, params_r_vec, pstream__);
      params_r.resize(params_r_vec.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r(i) = params_r_vec[i];
    }
    template <bool propto__, bool jacobian__, typename T__>
    T__ log_prob(std::vector<T__>& params_r__,
                 std::vector<int>& params_i__,
                 std::ostream* pstream__ = 0) const {
        typedef T__ local_scalar_t__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // dummy to suppress unused var warning
        T__ lp__(0.0);
        stan::math::accumulator<T__> lp_accum__;
        try {
            stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
            // model parameters
            current_statement_begin__ = 184;
            local_scalar_t__ lambda_mu;
            (void) lambda_mu;  // dummy to suppress unused var warning
            if (jacobian__)
                lambda_mu = in__.scalar_offset_multiplier_constrain(lambda_mu_mu, 1, lp__);
            else
                lambda_mu = in__.scalar_offset_multiplier_constrain(lambda_mu_mu, 1);
            current_statement_begin__ = 185;
            local_scalar_t__ lambda_sigma;
            (void) lambda_sigma;  // dummy to suppress unused var warning
            if (jacobian__)
                lambda_sigma = in__.scalar_lb_constrain(0, lp__);
            else
                lambda_sigma = in__.scalar_lb_constrain(0);
            current_statement_begin__ = 186;
            local_scalar_t__ lambda_skew;
            (void) lambda_skew;  // dummy to suppress unused var warning
            if (jacobian__)
                lambda_skew = in__.scalar_constrain(lp__);
            else
                lambda_skew = in__.scalar_constrain();
            current_statement_begin__ = 188;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> exposure_rate;
            (void) exposure_rate;  // dummy to suppress unused var warning
            if (jacobian__)
                exposure_rate = in__.vector_offset_multiplier_constrain(0, exposure_rate_multiplier, S, lp__);
            else
                exposure_rate = in__.vector_offset_multiplier_constrain(0, exposure_rate_multiplier, S);
            current_statement_begin__ = 191;
            Eigen::Matrix<local_scalar_t__, 1, Eigen::Dynamic> intercept;
            (void) intercept;  // dummy to suppress unused var warning
            if (jacobian__)
                intercept = in__.row_vector_constrain(G, lp__);
            else
                intercept = in__.row_vector_constrain(G);
            current_statement_begin__ = 192;
            Eigen::Matrix<local_scalar_t__, 1, Eigen::Dynamic> alpha_sub_1;
            (void) alpha_sub_1;  // dummy to suppress unused var warning
            if (jacobian__)
                alpha_sub_1 = in__.row_vector_constrain(how_many_to_check, lp__);
            else
                alpha_sub_1 = in__.row_vector_constrain(how_many_to_check);
            current_statement_begin__ = 193;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> alpha_2;
            (void) alpha_2;  // dummy to suppress unused var warning
            if (jacobian__)
                alpha_2 = in__.matrix_constrain(std::max(0, (C - 2)), how_many_to_check, lp__);
            else
                alpha_2 = in__.matrix_constrain(std::max(0, (C - 2)), how_many_to_check);
            current_statement_begin__ = 194;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> sigma_raw;
            (void) sigma_raw;  // dummy to suppress unused var warning
            if (jacobian__)
                sigma_raw = in__.vector_constrain(G, lp__);
            else
                sigma_raw = in__.vector_constrain(G);
            current_statement_begin__ = 198;
            local_scalar_t__ sigma_slope;
            (void) sigma_slope;  // dummy to suppress unused var warning
            if (jacobian__)
                sigma_slope = in__.scalar_ub_constrain(0, lp__);
            else
                sigma_slope = in__.scalar_ub_constrain(0);
            current_statement_begin__ = 199;
            local_scalar_t__ sigma_intercept;
            (void) sigma_intercept;  // dummy to suppress unused var warning
            if (jacobian__)
                sigma_intercept = in__.scalar_constrain(lp__);
            else
                sigma_intercept = in__.scalar_constrain();
            current_statement_begin__ = 200;
            local_scalar_t__ sigma_sigma;
            (void) sigma_sigma;  // dummy to suppress unused var warning
            if (jacobian__)
                sigma_sigma = in__.scalar_lb_constrain(0, lp__);
            else
                sigma_sigma = in__.scalar_lb_constrain(0);
            // transformed parameters
            current_statement_begin__ = 206;
            validate_non_negative_index("sigma", "G", G);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> sigma(G);
            stan::math::initialize(sigma, DUMMY_VAR__);
            stan::math::fill(sigma, DUMMY_VAR__);
            stan::math::assign(sigma,elt_divide(1.0, stan::math::exp(sigma_raw)));
            current_statement_begin__ = 207;
            validate_non_negative_index("alpha", "C", C);
            validate_non_negative_index("alpha", "G", G);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> alpha(C, G);
            stan::math::initialize(alpha, DUMMY_VAR__);
            stan::math::fill(alpha, DUMMY_VAR__);
            stan::math::assign(alpha,merge_coefficients(intercept, alpha_sub_1, alpha_2, C, S, G, pstream__));
            current_statement_begin__ = 208;
            validate_non_negative_index("lambda_log_param", "S", S);
            validate_non_negative_index("lambda_log_param", "G", G);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> lambda_log_param(S, G);
            stan::math::initialize(lambda_log_param, DUMMY_VAR__);
            stan::math::fill(lambda_log_param, DUMMY_VAR__);
            stan::math::assign(lambda_log_param,multiply(X, alpha));
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            current_statement_begin__ = 206;
            size_t sigma_j_1_max__ = G;
            for (size_t j_1__ = 0; j_1__ < sigma_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(sigma(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: sigma" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable sigma: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            current_statement_begin__ = 207;
            size_t alpha_j_1_max__ = C;
            size_t alpha_j_2_max__ = G;
            for (size_t j_1__ = 0; j_1__ < alpha_j_1_max__; ++j_1__) {
                for (size_t j_2__ = 0; j_2__ < alpha_j_2_max__; ++j_2__) {
                    if (stan::math::is_uninitialized(alpha(j_1__, j_2__))) {
                        std::stringstream msg__;
                        msg__ << "Undefined transformed parameter: alpha" << "(" << j_1__ << ", " << j_2__ << ")";
                        stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable alpha: ") + msg__.str()), current_statement_begin__, prog_reader__());
                    }
                }
            }
            current_statement_begin__ = 208;
            size_t lambda_log_param_j_1_max__ = S;
            size_t lambda_log_param_j_2_max__ = G;
            for (size_t j_1__ = 0; j_1__ < lambda_log_param_j_1_max__; ++j_1__) {
                for (size_t j_2__ = 0; j_2__ < lambda_log_param_j_2_max__; ++j_2__) {
                    if (stan::math::is_uninitialized(lambda_log_param(j_1__, j_2__))) {
                        std::stringstream msg__;
                        msg__ << "Undefined transformed parameter: lambda_log_param" << "(" << j_1__ << ", " << j_2__ << ")";
                        stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable lambda_log_param: ") + msg__.str()), current_statement_begin__, prog_reader__());
                    }
                }
            }
            // model body
            current_statement_begin__ = 213;
            lp_accum__.add(normal_log<propto__>(lambda_mu, lambda_mu_mu, 2));
            current_statement_begin__ = 214;
            lp_accum__.add(normal_log<propto__>(lambda_sigma, 0, 2));
            current_statement_begin__ = 215;
            lp_accum__.add(normal_log<propto__>(lambda_skew, 0, 1));
            current_statement_begin__ = 217;
            lp_accum__.add(normal_log<propto__>(sigma_intercept, 0, 2));
            current_statement_begin__ = 218;
            lp_accum__.add(normal_log<propto__>(sigma_slope, 0, 2));
            current_statement_begin__ = 219;
            lp_accum__.add(normal_log<propto__>(sigma_sigma, 0, 2));
            current_statement_begin__ = 222;
            lp_accum__.add(skew_normal_log<propto__>(to_vector(intercept), (lambda_mu + lambda_mu_mu), lambda_sigma, lambda_skew));
            current_statement_begin__ = 223;
            if (as_bool(logical_gte(C, 2))) {
                current_statement_begin__ = 223;
                lp_accum__.add(double_exponential_log<propto__>(alpha_sub_1, 0, 1));
            }
            current_statement_begin__ = 224;
            if (as_bool(logical_gte(C, 3))) {
                current_statement_begin__ = 224;
                lp_accum__.add(normal_log<propto__>(to_vector(alpha_2), 0, 2.5));
            }
            current_statement_begin__ = 226;
            lp_accum__.add(normal_log<propto__>(sigma_raw, add(multiply(sigma_slope, intercept), sigma_intercept), sigma_sigma));
            current_statement_begin__ = 229;
            lp_accum__.add(normal_log<propto__>(exposure_rate, 0, 1));
            current_statement_begin__ = 230;
            lp_accum__.add(normal_log<propto__>(sum(exposure_rate), 0, (0.001 * S)));
            current_statement_begin__ = 233;
            lp_accum__.add(sum(map_rect<1, lp_reduce_functor__>(global_parameters, get_reference_parameters_MPI(n_shards, M, G_per_shard, G_ind, lambda_log_param, sigma, exposure_rate, pstream__), real_data, counts_package, pstream__)));
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
        lp_accum__.add(lp__);
        return lp_accum__.sum();
    } // log_prob()
    template <bool propto, bool jacobian, typename T_>
    T_ log_prob(Eigen::Matrix<T_,Eigen::Dynamic,1>& params_r,
               std::ostream* pstream = 0) const {
      std::vector<T_> vec_params_r;
      vec_params_r.reserve(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        vec_params_r.push_back(params_r(i));
      std::vector<int> vec_params_i;
      return log_prob<propto,jacobian,T_>(vec_params_r, vec_params_i, pstream);
    }
    void get_param_names(std::vector<std::string>& names__) const {
        names__.resize(0);
        names__.push_back("lambda_mu");
        names__.push_back("lambda_sigma");
        names__.push_back("lambda_skew");
        names__.push_back("exposure_rate");
        names__.push_back("intercept");
        names__.push_back("alpha_sub_1");
        names__.push_back("alpha_2");
        names__.push_back("sigma_raw");
        names__.push_back("sigma_slope");
        names__.push_back("sigma_intercept");
        names__.push_back("sigma_sigma");
        names__.push_back("sigma");
        names__.push_back("alpha");
        names__.push_back("lambda_log_param");
        names__.push_back("counts_rng");
    }
    void get_dims(std::vector<std::vector<size_t> >& dimss__) const {
        dimss__.resize(0);
        std::vector<size_t> dims__;
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(S);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(G);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(how_many_to_check);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(std::max(0, (C - 2)));
        dims__.push_back(how_many_to_check);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(G);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(G);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(C);
        dims__.push_back(G);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(S);
        dims__.push_back(G);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(S);
        dims__.push_back(how_many_to_check);
        dimss__.push_back(dims__);
    }
    template <typename RNG>
    void write_array(RNG& base_rng__,
                     std::vector<double>& params_r__,
                     std::vector<int>& params_i__,
                     std::vector<double>& vars__,
                     bool include_tparams__ = true,
                     bool include_gqs__ = true,
                     std::ostream* pstream__ = 0) const {
        typedef double local_scalar_t__;
        vars__.resize(0);
        stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
        static const char* function__ = "model_negBinomial_MPI_namespace::write_array";
        (void) function__;  // dummy to suppress unused var warning
        // read-transform, write parameters
        double lambda_mu = in__.scalar_offset_multiplier_constrain(lambda_mu_mu, 1);
        vars__.push_back(lambda_mu);
        double lambda_sigma = in__.scalar_lb_constrain(0);
        vars__.push_back(lambda_sigma);
        double lambda_skew = in__.scalar_constrain();
        vars__.push_back(lambda_skew);
        Eigen::Matrix<double, Eigen::Dynamic, 1> exposure_rate = in__.vector_offset_multiplier_constrain(0, exposure_rate_multiplier, S);
        size_t exposure_rate_j_1_max__ = S;
        for (size_t j_1__ = 0; j_1__ < exposure_rate_j_1_max__; ++j_1__) {
            vars__.push_back(exposure_rate(j_1__));
        }
        Eigen::Matrix<double, 1, Eigen::Dynamic> intercept = in__.row_vector_constrain(G);
        size_t intercept_j_1_max__ = G;
        for (size_t j_1__ = 0; j_1__ < intercept_j_1_max__; ++j_1__) {
            vars__.push_back(intercept(j_1__));
        }
        Eigen::Matrix<double, 1, Eigen::Dynamic> alpha_sub_1 = in__.row_vector_constrain(how_many_to_check);
        size_t alpha_sub_1_j_1_max__ = how_many_to_check;
        for (size_t j_1__ = 0; j_1__ < alpha_sub_1_j_1_max__; ++j_1__) {
            vars__.push_back(alpha_sub_1(j_1__));
        }
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> alpha_2 = in__.matrix_constrain(std::max(0, (C - 2)), how_many_to_check);
        size_t alpha_2_j_2_max__ = how_many_to_check;
        size_t alpha_2_j_1_max__ = std::max(0, (C - 2));
        for (size_t j_2__ = 0; j_2__ < alpha_2_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_2_j_1_max__; ++j_1__) {
                vars__.push_back(alpha_2(j_1__, j_2__));
            }
        }
        Eigen::Matrix<double, Eigen::Dynamic, 1> sigma_raw = in__.vector_constrain(G);
        size_t sigma_raw_j_1_max__ = G;
        for (size_t j_1__ = 0; j_1__ < sigma_raw_j_1_max__; ++j_1__) {
            vars__.push_back(sigma_raw(j_1__));
        }
        double sigma_slope = in__.scalar_ub_constrain(0);
        vars__.push_back(sigma_slope);
        double sigma_intercept = in__.scalar_constrain();
        vars__.push_back(sigma_intercept);
        double sigma_sigma = in__.scalar_lb_constrain(0);
        vars__.push_back(sigma_sigma);
        double lp__ = 0.0;
        (void) lp__;  // dummy to suppress unused var warning
        stan::math::accumulator<double> lp_accum__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        if (!include_tparams__ && !include_gqs__) return;
        try {
            // declare and define transformed parameters
            current_statement_begin__ = 206;
            validate_non_negative_index("sigma", "G", G);
            Eigen::Matrix<double, Eigen::Dynamic, 1> sigma(G);
            stan::math::initialize(sigma, DUMMY_VAR__);
            stan::math::fill(sigma, DUMMY_VAR__);
            stan::math::assign(sigma,elt_divide(1.0, stan::math::exp(sigma_raw)));
            current_statement_begin__ = 207;
            validate_non_negative_index("alpha", "C", C);
            validate_non_negative_index("alpha", "G", G);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> alpha(C, G);
            stan::math::initialize(alpha, DUMMY_VAR__);
            stan::math::fill(alpha, DUMMY_VAR__);
            stan::math::assign(alpha,merge_coefficients(intercept, alpha_sub_1, alpha_2, C, S, G, pstream__));
            current_statement_begin__ = 208;
            validate_non_negative_index("lambda_log_param", "S", S);
            validate_non_negative_index("lambda_log_param", "G", G);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> lambda_log_param(S, G);
            stan::math::initialize(lambda_log_param, DUMMY_VAR__);
            stan::math::fill(lambda_log_param, DUMMY_VAR__);
            stan::math::assign(lambda_log_param,multiply(X, alpha));
            if (!include_gqs__ && !include_tparams__) return;
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            // write transformed parameters
            if (include_tparams__) {
                size_t sigma_j_1_max__ = G;
                for (size_t j_1__ = 0; j_1__ < sigma_j_1_max__; ++j_1__) {
                    vars__.push_back(sigma(j_1__));
                }
                size_t alpha_j_2_max__ = G;
                size_t alpha_j_1_max__ = C;
                for (size_t j_2__ = 0; j_2__ < alpha_j_2_max__; ++j_2__) {
                    for (size_t j_1__ = 0; j_1__ < alpha_j_1_max__; ++j_1__) {
                        vars__.push_back(alpha(j_1__, j_2__));
                    }
                }
                size_t lambda_log_param_j_2_max__ = G;
                size_t lambda_log_param_j_1_max__ = S;
                for (size_t j_2__ = 0; j_2__ < lambda_log_param_j_2_max__; ++j_2__) {
                    for (size_t j_1__ = 0; j_1__ < lambda_log_param_j_1_max__; ++j_1__) {
                        vars__.push_back(lambda_log_param(j_1__, j_2__));
                    }
                }
            }
            if (!include_gqs__) return;
            // declare and define generated quantities
            current_statement_begin__ = 267;
            validate_non_negative_index("counts_rng", "how_many_to_check", how_many_to_check);
            validate_non_negative_index("counts_rng", "S", S);
            std::vector<Eigen::Matrix<double, Eigen::Dynamic, 1> > counts_rng(S, Eigen::Matrix<double, Eigen::Dynamic, 1>(how_many_to_check));
            stan::math::initialize(counts_rng, DUMMY_VAR__);
            stan::math::fill(counts_rng, DUMMY_VAR__);
            // generated quantities statements
            current_statement_begin__ = 269;
            for (int g = 1; g <= how_many_to_check; ++g) {
                current_statement_begin__ = 269;
                for (int s = 1; s <= S; ++s) {
                    current_statement_begin__ = 271;
                    stan::model::assign(counts_rng, 
                                stan::model::cons_list(stan::model::index_uni(s), stan::model::cons_list(stan::model::index_uni(g), stan::model::nil_index_list())), 
                                neg_binomial_2_log_rng((get_base1(exposure_rate, s, "exposure_rate", 1) + get_base1(lambda_log_param, s, g, "lambda_log_param", 1)), (get_base1(sigma, g, "sigma", 1) * truncation_compensation), base_rng__), 
                                "assigning variable counts_rng");
                }
            }
            // validate, write generated quantities
            current_statement_begin__ = 267;
            size_t counts_rng_j_1_max__ = how_many_to_check;
            size_t counts_rng_k_0_max__ = S;
            for (size_t j_1__ = 0; j_1__ < counts_rng_j_1_max__; ++j_1__) {
                for (size_t k_0__ = 0; k_0__ < counts_rng_k_0_max__; ++k_0__) {
                    vars__.push_back(counts_rng[k_0__](j_1__));
                }
            }
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    template <typename RNG>
    void write_array(RNG& base_rng,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& params_r,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& vars,
                     bool include_tparams = true,
                     bool include_gqs = true,
                     std::ostream* pstream = 0) const {
      std::vector<double> params_r_vec(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r_vec[i] = params_r(i);
      std::vector<double> vars_vec;
      std::vector<int> params_i_vec;
      write_array(base_rng, params_r_vec, params_i_vec, vars_vec, include_tparams, include_gqs, pstream);
      vars.resize(vars_vec.size());
      for (int i = 0; i < vars.size(); ++i)
        vars(i) = vars_vec[i];
    }
    std::string model_name() const {
        return "model_negBinomial_MPI";
    }
    void constrained_param_names(std::vector<std::string>& param_names__,
                                 bool include_tparams__ = true,
                                 bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        param_name_stream__.str(std::string());
        param_name_stream__ << "lambda_mu";
        param_names__.push_back(param_name_stream__.str());
        param_name_stream__.str(std::string());
        param_name_stream__ << "lambda_sigma";
        param_names__.push_back(param_name_stream__.str());
        param_name_stream__.str(std::string());
        param_name_stream__ << "lambda_skew";
        param_names__.push_back(param_name_stream__.str());
        size_t exposure_rate_j_1_max__ = S;
        for (size_t j_1__ = 0; j_1__ < exposure_rate_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "exposure_rate" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t intercept_j_1_max__ = G;
        for (size_t j_1__ = 0; j_1__ < intercept_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "intercept" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t alpha_sub_1_j_1_max__ = how_many_to_check;
        for (size_t j_1__ = 0; j_1__ < alpha_sub_1_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "alpha_sub_1" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t alpha_2_j_2_max__ = how_many_to_check;
        size_t alpha_2_j_1_max__ = std::max(0, (C - 2));
        for (size_t j_2__ = 0; j_2__ < alpha_2_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_2_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "alpha_2" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t sigma_raw_j_1_max__ = G;
        for (size_t j_1__ = 0; j_1__ < sigma_raw_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "sigma_raw" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        param_name_stream__.str(std::string());
        param_name_stream__ << "sigma_slope";
        param_names__.push_back(param_name_stream__.str());
        param_name_stream__.str(std::string());
        param_name_stream__ << "sigma_intercept";
        param_names__.push_back(param_name_stream__.str());
        param_name_stream__.str(std::string());
        param_name_stream__ << "sigma_sigma";
        param_names__.push_back(param_name_stream__.str());
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t sigma_j_1_max__ = G;
            for (size_t j_1__ = 0; j_1__ < sigma_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "sigma" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t alpha_j_2_max__ = G;
            size_t alpha_j_1_max__ = C;
            for (size_t j_2__ = 0; j_2__ < alpha_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < alpha_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "alpha" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t lambda_log_param_j_2_max__ = G;
            size_t lambda_log_param_j_1_max__ = S;
            for (size_t j_2__ = 0; j_2__ < lambda_log_param_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < lambda_log_param_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "lambda_log_param" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
        }
        if (!include_gqs__) return;
        size_t counts_rng_j_1_max__ = how_many_to_check;
        size_t counts_rng_k_0_max__ = S;
        for (size_t j_1__ = 0; j_1__ < counts_rng_j_1_max__; ++j_1__) {
            for (size_t k_0__ = 0; k_0__ < counts_rng_k_0_max__; ++k_0__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "counts_rng" << '.' << k_0__ + 1 << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
    }
    void unconstrained_param_names(std::vector<std::string>& param_names__,
                                   bool include_tparams__ = true,
                                   bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        param_name_stream__.str(std::string());
        param_name_stream__ << "lambda_mu";
        param_names__.push_back(param_name_stream__.str());
        param_name_stream__.str(std::string());
        param_name_stream__ << "lambda_sigma";
        param_names__.push_back(param_name_stream__.str());
        param_name_stream__.str(std::string());
        param_name_stream__ << "lambda_skew";
        param_names__.push_back(param_name_stream__.str());
        size_t exposure_rate_j_1_max__ = S;
        for (size_t j_1__ = 0; j_1__ < exposure_rate_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "exposure_rate" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t intercept_j_1_max__ = G;
        for (size_t j_1__ = 0; j_1__ < intercept_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "intercept" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t alpha_sub_1_j_1_max__ = how_many_to_check;
        for (size_t j_1__ = 0; j_1__ < alpha_sub_1_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "alpha_sub_1" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t alpha_2_j_2_max__ = how_many_to_check;
        size_t alpha_2_j_1_max__ = std::max(0, (C - 2));
        for (size_t j_2__ = 0; j_2__ < alpha_2_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_2_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "alpha_2" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t sigma_raw_j_1_max__ = G;
        for (size_t j_1__ = 0; j_1__ < sigma_raw_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "sigma_raw" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        param_name_stream__.str(std::string());
        param_name_stream__ << "sigma_slope";
        param_names__.push_back(param_name_stream__.str());
        param_name_stream__.str(std::string());
        param_name_stream__ << "sigma_intercept";
        param_names__.push_back(param_name_stream__.str());
        param_name_stream__.str(std::string());
        param_name_stream__ << "sigma_sigma";
        param_names__.push_back(param_name_stream__.str());
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t sigma_j_1_max__ = G;
            for (size_t j_1__ = 0; j_1__ < sigma_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "sigma" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t alpha_j_2_max__ = G;
            size_t alpha_j_1_max__ = C;
            for (size_t j_2__ = 0; j_2__ < alpha_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < alpha_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "alpha" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
            size_t lambda_log_param_j_2_max__ = G;
            size_t lambda_log_param_j_1_max__ = S;
            for (size_t j_2__ = 0; j_2__ < lambda_log_param_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < lambda_log_param_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "lambda_log_param" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
        }
        if (!include_gqs__) return;
        size_t counts_rng_j_1_max__ = how_many_to_check;
        size_t counts_rng_k_0_max__ = S;
        for (size_t j_1__ = 0; j_1__ < counts_rng_j_1_max__; ++j_1__) {
            for (size_t k_0__ = 0; k_0__ < counts_rng_k_0_max__; ++k_0__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "counts_rng" << '.' << k_0__ + 1 << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
    }
}; // model
}  // namespace
typedef model_negBinomial_MPI_namespace::model_negBinomial_MPI stan_model;
#ifndef USING_R
stan::model::model_base& new_model(
        stan::io::var_context& data_context,
        unsigned int seed,
        std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
#endif
STAN_REGISTER_MAP_RECT(1, model_negBinomial_MPI_namespace::lp_reduce_functor__)
#endif
